'use strict';

const
	_ = require('lodash'),
	Promise = require('bluebird');

exports.streamToPromise = function(stream){
	return new Promise((resolve, reject) => {
		stream.stopOnError(reject).toArray(resolve);
	});
};

exports.joinBuffer = function(bufferArray){
	let totalSize = _.reduce(bufferArray, (total, b) => total + b.length, 0);
	return Buffer.concat(bufferArray, totalSize);
};
